<template>
  <v-dialog v-model="dialogUser" @click:outside="close" max-width="50%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <AdminUsersUserForm :user="user" :isNewUser="isNewUser" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" class="text-uppercase" data-cy="UserFormCancelBtn" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" class="text-uppercase inverted" data-cy="UserFormOkBtn" :disabled="!meta.valid"
          :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { User } from "~/dto/user.dto";

const dialogUser = defineModel<boolean>()

const props = defineProps<{
  isNewUser: boolean,
  user: User
}>()

const emit = defineEmits(['close', 'confirm']);

const { validate, meta } = useForm({
  initialValues: props.user
})

const dialogTitle = ref(props.user.email ? `Édition d'un utilisateur` : `Création d'un utilisateur`);
const loading = ref(false);

const close = () => {
  emit('close');
};

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
};
</script>
